datablock fxDTSBrickData(brickServerSpawnData : brickSpawnPointData)
{
	uiName = "Server Spawn";
};

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) 
{ 
	if(!$RTB::RTBR_InfoTips_Hook) 
		exec("Add-Ons/System_ReturnToBlockland/RTBR_InfoTips_Hook.cs"); 
	RTB_addInfoTip("This server is running Server Wide Spawn Bricks, meaning you'll always spawn at a super-admin placable server spawn brick, unless you make your own spawn!","","Brick_ServerSpawn");
}

if(!isObject(ServerSpawnGroup))
	new SimSet(ServerSpawnGroup){};

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Override Client Spawns", "Server Spawn Bricks", "$Pref::Server::ServerSpawnOverride", "bool", "Brick_ServerSpawn", 0, 0, 0);
}
else
{
	$Pref::Server::ServerSpawnOverride = 0;
}

package serverSpawns
{
	function serverCmdPlantBrick(%client)
	{
		if(!isObject(%client.player.tempBrick))
			return;
		%ghostdata = %client.player.tempBrick.getDatablock().getName();
		if(%ghostdata $= "brickServerSpawnData" && !%client.isSuperAdmin)
		{
			%client.centerPrint("This brick can only be planted by a super admin!",3);
			return;
		}
		Parent::serverCmdPlantBrick(%client);
	}
	
	function brickServerSpawnData::onPlant(%this,%brick)
	{
		Parent::onPlant(%this,%brick);	
		ServerSpawnGroup.add(%brick);
	}
	
	function GameConnection::createPlayer(%this,%trans)
	{
		if(%this.minigame || ServerSpawnGroup.getCount() < 1 || (!$Pref::Server::ServerSpawnOverride && %this.brickGroup.spawnBrickCount))
			Parent::createPlayer(%this,%trans);
		else
			Parent::createPlayer(%this,getServerSpawnBrick());
	}
};
ActivatePackage(serverSpawns);

function getServerSpawnBrick()
{
	%num = ServerSpawnGroup.getCount();
	%i = getRandom(0,%num-1);
	%spawn = ServerSpawnGroup.getObject(%i);
	return %spawn.getTransform();
		
}